﻿using BPA.KitChen.GroupMealOrder.Application.BaseDto;
using BPA.KitChen.GroupMealOrder.Application.Service.WeighOrder.Dtos;
using BPA.KitChen.GroupMealOrder.Core.Entity;
using Furion.DatabaseAccessor;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BPA.KitChen.GroupMealOrder.Application.Service.WeighOrder.Service
{
    public interface IWeighOrderService
    {

        /// <summary>
        /// 创建订单
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<WeighOrderDto> CreateWeighOrder(WeighOrderCreteDto inputDto);

        /// <summary>
        /// 添加订单商品
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<bool> AddWeighOrderGoods(List<WeighOrderGoodsCreateDto> inputDto);

        /// <summary>
        /// 添加订单餐盘
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<bool> AddWeighOrderDiningPlate(List<WeighOrderDiningPlateCreateDto> inputDto);

        /// <summary>
        /// 查询订单商品
        /// </summary>
        /// <param name="inputDto"></param>
        /// <returns></returns>
        Task<WeighOrderDto> GetWeighOrder(GetOrderInputDto inputDto);

        /// <summary>
        /// 修改订单状态
        /// </summary>
        /// <returns></returns>
        Task<bool> UpdateWeighOrderStates(WeighOrderUpdateDto inputDto);

        /// <summary>
        /// 添加 餐盘解绑记录
        /// </summary>
        /// <param name="inputDto">餐盘ID</param>
        /// <returns></returns>
        Task<bool> AddWeighOrderDiningPlateUnbindRecord(List<string> inputDto);

        /// <summary>
        /// 获取餐盘绑定信息
        /// </summary>
        /// <param name="inputDto">餐盘ID</param>
        /// <returns></returns>
        Task<List<DiningPlateDto>> GetDiningPlateOccupyInfo(List<string> inputDto);


        /// <summary>
        /// 更具openid获取称重订单
        /// </summary>
        /// <returns></returns>
        Task<PageUtil> GetWeighOrderByOpenId(GetWeighOrderByOpenIdInputDto inputDto);
    }
}
